<template>
  <div>
      <el-breadcrumb separator-class="el-icon-arrow-right">
        <el-breadcrumb-item :to="{ path: '/home' }">首页</el-breadcrumb-item>
        <el-breadcrumb-item>商品管理</el-breadcrumb-item>
        <el-breadcrumb-item>商品分类</el-breadcrumb-item>
      </el-breadcrumb>

      <el-card>
          <el-row>
              <el-col>
                  <el-button 
                  type="primary"
                  @click="addCateDialogVisibles"
                  >添加分类</el-button>
              </el-col>
          </el-row>

        <tree-table
        class="treeTable"
        :data="cateList"
        :columns="columns"
        :selection-type="false"
        :expand-type="false"
        show-index
        index-text="#"
        border
        >
            //是否有效模板
            <template slot="isok" slot-scope="scope">
                <i class="el-icon-success" 
                v-if="scope.row.cat_deleted === false"
                style="color: lightgreen;"></i>
                <i class="el-icon-error" 
                v-else
                style="color: red;"></i>
            </template>

            <!-- 排序模板 -->
            <template slot-scope="scope" slot="order">
                <el-tag v-if="scope.row.cat_level === 0">一级</el-tag>
                <el-tag type="success" v-else-if="scope.row.cat_level === 1">二级</el-tag>
                <el-tag type="warning" v-else>三级</el-tag>
            </template>

            <!-- 操作模板 -->
            <template slot="operation" slot-scope="scope">
                <el-button 
                type="primary" 
                icon="el-icon-edit" 
                size="mini"
                @click="changeGoods(scope)"
                >修改</el-button>

                <el-button
                type="danger" 
                icon="el-icon-delete" 
                size="mini"
                @click="delGoods(scope)"
                >删除</el-button>
            </template>
        </tree-table>
        
        <!-- 分页区域 -->
        <el-pagination
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        :current-page="queryInfo.pagenum"
        :page-sizes="[5, 10, 15, 20]"
        :page-size="queryInfo.pagesize"
        layout="total, sizes, prev, pager, next, jumper"
        :total="total">
        </el-pagination>
      </el-card>

      <!-- 添加分类 -->
      <el-dialog
        title="添加分类"
        :visible.sync="addCateDialogVisible"
        width="60%">
        <!-- 添加分类表单 -->
        <el-form :model="addCateForm" :rules="addCateFormRules" label-width="100px">
            <el-form-item label="分类名称" prop="cat_name">
                <el-input v-model="addCateForm.cat_name">
                </el-input>
            </el-form-item>
            <!-- options用来指定数据源 -->
            <!-- props用来指定配置对象 -->
            <!-- <el-form-item label="父级分类">
                <el-cascader
                    v-model="cascaderProps"
                    :options="parentCateList"
                    :props="{expandTrigger:'hover'}"
                    @change="parentHandleChange"
                    clearable
                    change-on-select="">
                </el-cascader>
            </el-form-item> -->
        </el-form>

        <span slot="footer" class="dialog-footer">
            <el-button @click="addCateDialogVisible = false">取 消</el-button>
            <el-button type="primary" @click="addCateDialogVisible = false">确 定</el-button>
        </span>
    </el-dialog>
  </div>
</template>

<script>
export default {
    data(){
        return{
            // 查询条件
            queryInfo:{
                type: 3,
                pagenum: 1,
                pagesize: 5
            },
            //商品分类数据列表，默认空
            cateList: [],
            total: 0,
            columns:[
                {
                    label: '分类名称',
                    prop: 'cat_name'
                },
                {
                    label: '是否有效',
                    //当前列定义为模板列
                    type: 'template',
                    //表示当前模板名称
                    template: 'isok'
                },
                {
                    label: '排序',
                    //当前列定义为模板列
                    type: 'template',
                    //表示当前模板名称
                    template: 'order'
                },
                {
                    label: '操作',
                    //当前列定义为模板列
                    type: 'template',
                    //表示当前模板名称
                    template: 'operation',
                    width: '200px'
                }
            ],
            addCateDialogVisible: false,
            addCateForm:{
                cat_pid: 0,
                cat_name: '',
                cat_level: 0
            },
            addCateFormRules:{
                cat_name:[
                    { required: true, message: '请添加分类名称', trigger: 'blur' }
                ]
            },
            parentCateList: [],
            cascaderProps: {
                vaule: 'cat_id',
                label: 'cat_name',
                children: 'children'  
            },
            // 选中的父级分类数组
            selectedKeys: []
        }
    },
    created(){
        this.getGoodsList()
    },
    methods:{
        async getGoodsList(){
            const {data:res} = await this.$http.get("categories", {params: this.queryInfo})
            // console.log(res);
            if(res.meta.status !== 200) return this.$message.error("商品分类获取失败");
            this.cateList = res.data.result
            this.total = res.data.total
        },
        // 监听page-size 改变
        handleSizeChange(newSize){
            this.queryInfo.pagesize = newSize
            this.getGoodsList()
        },
        // 监听pagenum 改变
        handleCurrentChange(newPage){
            this.queryInfo.pagenum = newPage
            this.getGoodsList()
        },
        async changeGoods(){
            const {data:res} = await this.$http.put(`categories/${scope.row.id}`)
        },
        addCateDialogVisibles(){
            // 获取父级分类的数据列表
            this.getParentCateList()
            this.addCateDialogVisible = true
        },
        // 获取父级分类的数据列表
        async getParentCateList(){    
            const {data:res} = await this.$http.get("categories", { params: {type: 2}})
            if(res.meta.status !== 200) return this.$message.error("获取父级分类失败");
            // console.log(res.data[2].cat_name);
            this.parentCateList = res.data
        },
        // 选择项发生变化，触发函数
        parentHandleChange(){
            // console.log(this.selectedKeys);
        
        }
    }
}
</script>

<style scoped>
.treeTable {
    margin-top: 15px;
}
.el-cascader {
    width: 100%;
}
</style>